"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveMarkdown = void 0;
const unified_1 = __importDefault(require("unified"));
const remark_parse_1 = __importDefault(require("remark-parse"));
const rehypeMarkdownToMarkdown_1 = __importDefault(require("./rehypeMarkdownToMarkdown"));
// import stringify from 'rehype-stringify';
const mdast_util_to_markdown_1 = __importDefault(require("mdast-util-to-markdown"));
const mdast_util_gfm_table_1 = __importDefault(require("mdast-util-gfm-table"));
const gray_matter_1 = __importDefault(require("gray-matter"));
const utils_sh_1 = require("@goldstack/utils-sh");
async function resolveMarkdown(filePath) {
    try {
        let tree = undefined;
        tree = (0, unified_1.default)()
            .use(remark_parse_1.default)
            // .use(rehypeMarkdown, { filePath })
            .parse((0, gray_matter_1.default)((0, utils_sh_1.read)(filePath)).content);
        tree = (0, rehypeMarkdownToMarkdown_1.default)({ filePath })(tree);
        // const file = await processor.process(md);
        // console.log(JSON.stringify(tree, null, 2));
        const file = (0, mdast_util_to_markdown_1.default)(tree, {
            extensions: [mdast_util_gfm_table_1.default.toMarkdown()],
        });
        // Replace non-breaking spaces (char code 160) with normal spaces to avoid style issues
        return file.replace(/\xA0/g, ' ');
    }
    catch (error) {
        console.error(`Markdown to Markdown error: ${error}`);
        throw error;
    }
}
exports.resolveMarkdown = resolveMarkdown;
//# sourceMappingURL=resolveMarkdown.js.map